﻿var rowIndex = -1;
var parameterToBeEdited = null;
function InitParametersPanel()
{
    objAddEditParameterPanel = document.getElementsByName("pnlAddEditParameter")[0];
    objParameterName = document.form1.tbParameterName;
    objParameterDataType = document.form1.ddlParameterDataType;
    objLength = document.form1.tbLength;
    objPrecision = document.form1.tbPrecision;
    objScale = document.form1.tbScale;
    objIsRefCursor = document.form1.cbIsRefCursor;
    objIsOutputParameter = document.form1.cbIsOutputParameter;
    objIsReadonly = document.form1.cbIsReadonly;
    objParameterDefaultValue = document.form1.tbDefault;
}

function ShowAddEditParameterPanel()
{
    InitializeAddEditParameterPanel();
    objAddEditParameterPanel.style.display = "block";
    CenterIt(objAddEditParameterPanel);
}

function HideAddEditParameterPanel()
{
    objAddEditParameterPanel.style.display = "none";
    parameterToBeEdited = null;
    rowIndex = -1;
    mode = "A";
}


function InitializeAddEditParameterPanel()
{
    parameterToBeEdited = null;
    objParameterName.value = "";
    objParameterDataType.selectedIndex = 0;
    objLength.className = "tfsd";
    objLength.readOnly = true;
    objLength.value = "";
    objPrecision.className = "tfsd";
    objPrecision.readOnly = true;
    objPrecision.value = "";
    objScale.className = "tfsd";
    objScale.readOnly = true;
    objScale.value = "";
    objIsRefCursor.disabled = false;
    objIsRefCursor.checked = false;
    objIsOutputParameter.disabled = false;
    objIsOutputParameter.checked = false;
    objIsReadonly.disabled = true;
    objIsReadonly.checked = false;
    objParameterDefaultValue.value = "";
    objParameterDefaultValue.className = "tfs";
    objParameterDefaultValue.disabled = false;
}


function ddlParameterDataType_OnChange(obj)
{
    dataTypeValue = trim(obj.value.toLowerCase());
    objLength.className = "tfsd";
    objLength.readOnly = true;
    objLength.value = "";
    objPrecision.className = "tfsd";
    objPrecision.readOnly = true;
    objPrecision.value = "";
    objScale.className = "tfsd";
    objScale.readOnly = true;
    objScale.value = "";
    var selectedDataType = null;
    for (var i=0; i<dataTypes.length; i++)
    {
        if (dataTypes[i].Name.toLowerCase() == dataTypeValue)
        {
            selectedDataType = dataTypes[i];
            break;
        }
    }    
    if (selectedDataType != null)
    {
        var isOriginalDataType = false;            
        objLength.value = selectedDataType.DefaultLength;
        if (selectedDataType.IsUserDefinedTableType)
        {
            objIsReadonly.checked = true;
            objParameterDefaultValue.value = "";
            objParameterDefaultValue.className = "tfsd";
            objParameterDefaultValue.readOnly = true;
            objIsOutputParameter.disabled = true; 
            objIsOutputParameter.checked = false; 
        }
        else
        {
            objIsReadonly.checked = false;
            objParameterDefaultValue.value = "";
            objParameterDefaultValue.className = "tfs";
            objParameterDefaultValue.readOnly = false;
            objIsOutputParameter.disabled = false; 
        }
        if (selectedDataType.IsLengthEditable)
        {
            objLength.className = "tfs";
            objLength.readOnly = false;
        }
        else
        {
            objLength.className = "tfsd";
            objLength.readOnly = true;
        }
        objPrecision.value = selectedDataType.DefaultPrecision;
        if (selectedDataType.IsPrecisionEditable)
        {
            objPrecision.className = "tfs";
            objPrecision.readOnly = false;
        }
        else
        {
            objPrecision.className = "tfsd";
            objPrecision.readOnly = true;
        }
        objScale.value = selectedDataType.DefaultScale;
        if (selectedDataType.IsScaleEditable)
        {
            objScale.className = "tfs";
            objScale.readOnly = false;
        }
        else
        {
            objScale.className = "tfsd";
            objScale.readOnly = true;
        }

        if (mode == "E")
        {
            if (selectedDataType.Name.toLowerCase() == parameterToBeEdited.dataType.toLowerCase())
            {
                isOriginalDataType = true;  
            }
        }

        if (isOriginalDataType)
        {
            objLength.value = parameterToBeEdited.length;
            objPrecision.value = parameterToBeEdited.precision;
            objScale.value = parameterToBeEdited.scale;
        }
        else
        {
            objLength.value = selectedDataType.DefaultLength;
            objPrecision.value = selectedDataType.DefaultPrecision;
            objScale.value = selectedDataType.DefaultScale;
        }
    }
}

//If a parameter is of type RefCursor it can only be output parameter
function cbIsRefCursor_OnClick(obj)
{
    objIsOutputParameter.disabled = false; 
    objParameterDefaultValue.disabled = false;
    objParameterDefaultValue.className = "tfs";
    if (obj.checked)
    {
       objIsOutputParameter.checked = true;
       objIsOutputParameter.disabled = true; 
       objParameterDefaultValue.value = "";
       objParameterDefaultValue.className = "tfsd";
       objParameterDefaultValue.disabled = true;
    }    
}

function btnSaveParameter_OnClick()
{
    if (ValidateParameter())
    {
        if (mode == "A")
        {
           btnNewParameter_OnClick(); 
        }
        else
        {
            btnCancelParameter_OnClick();
        }    
    }
    return false;
}

function btnCancelParameter_OnClick()
{
    HideAddEditParameterPanel();
    return false;
}

function ValidateParameter()
{
    objParameterName.value = trim(objParameterName.value);
    objParameterDataType.value = trim(objParameterDataType.value);
    objLength.value = trim(objLength.value);
    objPrecision.value = trim(objPrecision.value);
    objScale.value = trim(objScale.value);
    dataTypeText = "";
    if (objParameterName.value == "") 
    { 
        alert("Parameter name is required.");
        objParameterName.focus();
        return false;
    }    
    //Check for valid column name
    //First character can only be @.
    paramName = objParameterName.value;
    firstChar = paramName.charAt(0).toLowerCase();
    if (firstChar != "@")
    {
        alert("Invalid parameter name. Parameter name must begin with an at sign (@)");
        objParameterName.select();
        return false;
    }
    if (paramName.length < 2)
    {
        alert("Invalid parameter name length.");
        objParameterName.select();
        return false;
    }
    for (var i=1; i<paramName.length; i++)
    {
        characterValue = paramName.charAt(i).toLowerCase();
        if (! ((characterValue >= '0' && characterValue <= 9) || (characterValue >= 'a' && characterValue <= 'z') || (characterValue == '_')))
        {   
            alert("Invalid parameter name.");
            objParameterName.select();
            return false;
        }
    }
    //Check for duplicate parameter name
    for (var i=0; i<parameters.length; i++)
    {
        if ( (parameters[i].name.toLowerCase() == objParameterName.value.toLowerCase()) )
        {
            if (i != rowIndex)
            {
                alert("Duplicate parameter name found. Parameter names must be unique in a stored procedure");
                objParameterName.select();
                return false;
            }
        }
    }
    if (objParameterDataType.value == "" && ! objIsRefCursor.checked) 
    { 
        alert("Parameter data type is required. Data type is ignored if the parameter is a cursor.");
        objParameterDataType.focus();
        return false;
    }    
    var selectedDataType = null;
    for (var i=0; i<dataTypes.length; i++)
    {
        if (dataTypes[i].Name.toLowerCase() == objParameterDataType.value.toLowerCase())
        {
            selectedDataType = dataTypes[i];
            break;
        }
    }    
    if (selectedDataType != null)
    {
        if (selectedDataType.IsLengthEditable)
        {
            minLength = selectedDataType.MinimumLength;
            maxLength = selectedDataType.MaximumLength;
            if (! CheckInteger(objLength, minLength, maxLength))
            {
                objLength.select();
                return false;
            }
        }
        if (selectedDataType.IsPrecisionEditable)
        {
            minPrecision = selectedDataType.MinimumPrecision;
            maxPrecision = selectedDataType.MaximumPrecision;
            if (! CheckInteger(objPrecision, minPrecision, maxPrecision))
            {
                objPrecision.select();
                return false;
            }
        }
        if (selectedDataType.IsScaleEditable)
        {
            minScale = selectedDataType.MinimumScale;
            maxScale = selectedDataType.MaximumScale;
            if (! CheckInteger(objScale, minScale, maxScale))
            {
                objScale.select();
                return false;
            }
        }
        if (selectedDataType.IsPrecisionEditable && selectedDataType.IsScaleEditable)
        {
            if (objPrecision.value != "" && objScale.value != "")
            {
                if (parseInt(objPrecision.value, 10) <= parseInt(objScale.value, 10))
                {
                    alert("Precision value should be greater than scale value");
                    objScale.select();
                    return false;
                }
            }
        }
        dataTypeText = selectedDataType.Format;
        dataTypeText = dataTypeText.replace("$Name$", selectedDataType.Name);
        dataTypeText = dataTypeText.replace("$Length$", objLength.value);
        dataTypeText = dataTypeText.replace("$Precision$", objPrecision.value);
        dataTypeText = dataTypeText.replace("$Scale$", objScale.value);
    }
    if (mode == "A")
    {
        var par = new Parameter(-1, objParameterName.value, objParameterDataType.value, dataTypeText, objLength.value, objPrecision.value, objScale.value, objIsOutputParameter.checked, objIsReadonly.checked, objIsRefCursor.checked, objParameterDefaultValue.value);
        if (objIsRefCursor.checked)
        {
           par.dataType = "int";
           par.dataTypeText = "int";
        }
        parameters[parameters.length] = par;
        PaintNewParameterRow(par, parameters.length-1);
    }
    else if (mode == "E")
    {
        var par = new Parameter(parameterToBeEdited.id, objParameterName.value, objParameterDataType.value, dataTypeText, objLength.value, objPrecision.value, objScale.value, objIsOutputParameter.checked, objIsReadonly.checked, objIsRefCursor.checked, objParameterDefaultValue.value);
        if (objIsRefCursor.checked)
        {
           par.dataType = "int";
           par.dataTypeText = "int";
        }
        parameters[rowIndex] = par;
        PaintEditParameterRow(par, rowIndex);
    }
    return true;
}

function PaintEditParameterRow(thisParameter, rowIndex)
{
    if (isIE)
    {
        tr = document.getElementById("par_" + rowIndex);
        //Parameter name
        td = tr.cells(0);
        td.innerHTML = thisParameter.name;
        //Parameter Data Type;
        td = tr.cells(1);
        td.innerHTML = thisParameter.isRefCursor ? "N/A" : thisParameter.dataTypeText;
        //Ref Cursor;
        td = tr.cells(2);
        td.innerHTML = thisParameter.isRefCursor ? trueText : "&nbsp;";
        //Output
        td = tr.cells(3);
        td.innerHTML = thisParameter.isOutput ? trueText : "&nbsp;";
        //Default value
        td = tr.cells(4);
        td.innerHTML = thisParameter.defaultValue;
    }
}

function PaintNewParameterRow(newParameter, thisParameterIndex)
{
    if (isIE)
    {
        tr = objParametersTable.insertRow();
        rowid = "par_" + thisParameterIndex;
        tr.id = rowid;
        tr.setAttribute("name", rowid);
        //Parameter Name;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "left";
        td.innerHTML = newParameter.name;
        //Parameter Data Type;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "left";
        td.innerHTML = newParameter.isRefCursor ? "N/A" : newParameter.dataTypeText;
        //Ref Cursor;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "center";
        td.innerHTML = newParameter.isRefCursor ? trueText : "&nbsp;";
        //Output;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "center";
        td.innerHTML = newParameter.isOutput ? trueText : "&nbsp;";
        //Default Value;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "left";
        td.innerHTML = newParameter.defaultValue;
        //Edit & Delete
        editHTML = "<a href='#' onClick='EditParameter(" + thisParameterIndex + ")'>" + editText + "</a>";
        deleteHTML = "<a href='#' onClick='DeleteParameter(" + thisParameterIndex + ")'>" + deleteText + "</a>";
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = editHTML + "&nbsp;&nbsp;" + deleteHTML;
    }
}

function EditParameter(parameterIndex)
{
    try
    {
        InitializeAddEditParameterPanel();
        rowIndex = parameterIndex;
        parameterToBeEdited = parameters[parameterIndex];
        mode = "E";
        objParameterName.value = parameterToBeEdited.name;
        objParameterDataType.value = parameterToBeEdited.dataType;
        ddlParameterDataType_OnChange(objParameterDataType);
        objLength.value = parameterToBeEdited.length;
        objPrecision.value = parameterToBeEdited.precision;
        objScale.value = parameterToBeEdited.scale;
        objIsReadonly.checked = parameterToBeEdited.isReadOnly;
        objIsRefCursor.checked = parameterToBeEdited.isRefCursor;
        if (objIsRefCursor.checked)
        {
            objIsOutputParameter.checked = true;
            objIsOutputParameter.disabled = true;
        }
        if (objIsReadonly.checked)
        {
            objParameterDefaultValue.value = "";
            objParameterDefaultValue.className = "tfsd";
            objParameterDefaultValue.readOnly = true;
            objIsOutputParameter.disabled = true; 
            objIsOutputParameter.checked = false; 
        }
        else
        {
            objParameterDefaultValue.className = "tfs";
            objParameterDefaultValue.readOnly = false;
            objIsOutputParameter.disabled = false; 
            objIsOutputParameter.checked = false; 
        }
        objIsOutputParameter.checked = parameterToBeEdited.isOutput;
        objParameterDefaultValue.value = parameterToBeEdited.defaultValue;
        objAddEditParameterPanel.style.display = "block";
        objParameterName.select();
        CenterIt(objAddEditParameterPanel);
    }
    catch (e)
    {
    }
}
function DeleteParameter(parameterIndex)
{
    thisParameter = parameters[parameterIndex];
    var confirmDelete = true;
    if (thisParameter.id >= 0)
    {
        confirmDelete = window.confirm("Are you sure you want to delete this parameter?");
    }
    if (confirmDelete)
    {
        thisParameter.isParameterDeleted = true;
        parameters[parameterIndex] = thisParameter;
        rowObjId = "par_" + parameterIndex;
        rowObj = document.getElementsByName(rowObjId)[0];
		if (isIE) { ri = rowObj.rowIndex; objParametersTable.deleteRow(ri); }
		else { deletedRow = objParametersTable.removeChild(rowObj); }
    }
}
