﻿var objSynonymDesigner = null;
var objPropertiesPanel = null;
var objSQLPanel = null;
var objPropertiesTab = null;
var objSQLTab = null;
var objTablePleaseWait = null;
var objCellPleaseWaitMessage = null;
var objSchema = null;
var objSynonymName = null;
var objTbSQL = null;
var objTbBaseServer = null;
var objTbBaseDatabase = null;
var objTbBaseSchema = null;
var objTbBaseObject = null;
var synonymMode = "N";

function BodyOnLoad()
{
    try
    {
        objSynonymDesigner = document.getElementsByName("tblSynonymDesigner")[0];
        objPropertiesPanel = document.getElementsByName("pnlProperties")[0];
        objSQLPanel = document.getElementsByName("pnlSQL")[0];
        objPropertiesTab = document.getElementsByName("tabProperties")[0];
        objSQLTab = document.getElementsByName("tabSQL")[0];
        objTablePleaseWait = document.getElementsByName("tblPleaseWait")[0];
        objCellPleaseWaitMessage = document.getElementsByName("cellPleaseWaitMessage")[0];
        objSchema = document.form1.ddlSchema;
        objSynonymName = document.form1.tbSynonymName;
        objTbSQL = document.form1.tbSQL;
        objTbBaseServer = document.form1.tbBaseServerName;
        objTbBaseDatabase = document.form1.tbBaseDatabaseName;
        objTbBaseSchema = document.form1.tbBaseSchemaName;
        objTbBaseObject = document.form1.tbBaseObjectName;
    }
    catch (e)
    {
    }
}

function PropertiesTabClicked(obj)
{
    objSQLTab.className = "itabr";
    objPropertiesTab.className = "atabr";
    objSQLPanel.style.display = "none";
    objPropertiesPanel.style.display = "block";
    return false;
}

function SQLTabClicked(obj)
{
    if(ValidateSynonym())
    { 
        objSQLTab.className = "atabr";
        objPropertiesTab.className = "itabr";
        objSQLPanel.style.display = "block";
        objPropertiesPanel.style.display = "none";
        Omega.Web.MSSQL.SynonymDesigner.BuildCreateSynonymSqlStatement(trim(objSchema.value), trim(objSynonymName.value), trim(objTbBaseServer.value), trim(objTbBaseDatabase.value), trim(objTbBaseSchema.value), trim(objTbBaseObject.value), BuildCreateSynonymSqlStatement_Callback);
    }
    return false;
}

function BuildCreateSynonymSqlStatement_Callback(resp)
{
    objSQLTab.className = "atabr";
    objPropertiesTab.className = "itabr";
    objSQLPanel.style.display = "block";
    objPropertiesPanel.style.display = "none";
    objTbSQL.value = resp.value;
}

function btnTestSql_OnClick()
{
    if(ValidateSynonym())
    { 
        objSynonymDesigner.style.display = "none";
        objTablePleaseWait.style.display = "block";
        objCellPleaseWaitMessage.innerHTML = checkSqlText;
        Omega.Web.MSSQL.SynonymDesigner.ValidateSql(trim(objSchema.value), trim(objSynonymName.value), trim(objTbBaseServer.value), trim(objTbBaseDatabase.value), trim(objTbBaseSchema.value), trim(objTbBaseObject.value), ValidateSql_Callback);
    }
    return false;
}

function ValidateSql_Callback(resp)
{
    alert(resp.value);
    objSynonymDesigner.style.display = "block";
    objTablePleaseWait.style.display = "none";
}

function btnExecuteSql_OnClick()
{
    if(ValidateSynonym())
    { 
        objSynonymDesigner.style.display = "none";
        objTablePleaseWait.style.display = "block";
        objCellPleaseWaitMessage.innerHTML = savingTableText;
        Omega.Web.MSSQL.SynonymDesigner.CreateSynonym(trim(objSchema.value), trim(objSynonymName.value), trim(objTbBaseServer.value), trim(objTbBaseDatabase.value), trim(objTbBaseSchema.value), trim(objTbBaseObject.value), CreateSynonym_Callback);
    }
    return false;
}

function CreateSynonym_Callback(resp)
{
    respval = resp.value;
    isError = true;
    message = "Unable to update the database";
    if (respval != null)
    {
        respvalarray = respval.split("|");
        message = respvalarray[1];
        if (respval.charAt(0) == "0")
        {
            isError = false;
        }
    }
    alert(message);
    if (isError)
    {
        objSynonymDesigner.style.display = "block";
        objTablePleaseWait.style.display = "none";
    }
    else
    {
        window.opener.SynonymDesignerComplete(synonymMode, document.form1.synonymId.value, trim(objSynonymName.value));
        self.close();
    }
}


function ValidateSynonym()
{
    objSynonymName.value = trim(objSynonymName.value);
    objTbBaseServer.value = trim(objTbBaseServer.value);
    objTbBaseDatabase.value = trim(objTbBaseDatabase.value);
    objTbBaseSchema.value = trim(objTbBaseSchema.value);
    objTbBaseObject.value = trim(objTbBaseObject.value);
    if (objSynonymName.value == "")
    {
        alert("Synonym name is required.");
        objSynonymName.focus();
        return false;
    }
    if (objTbBaseServer.value != "")
    {
        if (objTbBaseDatabase.value == "")
        {
            alert("Please specify the database for which you are creating this synonym");
            PropertiesTabClicked(null);
            objTbBaseDatabase.focus();
            return false;
        }
        if (objTbBaseSchema.value == "")
        {
            alert("Please specify the schema for which you are creating this synonym");
            PropertiesTabClicked(null);
            objTbBaseSchema.focus();
            return false;
        }
        if (objTbBaseObject.value == "")
        {
            alert("Please specify the database object for which you are creating this synonym");
            PropertiesTabClicked(null);
            objTbBaseObject.focus();
            return false;
        }
    }
    if (objTbBaseDatabase.value != "")
    {
        if (objTbBaseSchema.value == "")
        {
            alert("Please specify the schema for which you are creating this synonym");
            PropertiesTabClicked(null);
            objTbBaseSchema.focus();
            return false;
        }
        if (objTbBaseObject.value == "")
        {
            alert("Please specify the database object for which you are creating this synonym");
            PropertiesTabClicked(null);
            objTbBaseObject.focus();
            return false;
        }
    }
    if (objTbBaseSchema.value != "")
    {
        if (objTbBaseObject.value == "")
        {
            alert("Please specify the database object for which you are creating this synonym");
            PropertiesTabClicked(null);
            objTbBaseObject.focus();
            return false;
        }
    }
    if (objTbBaseObject.value == "")
    {
        alert("Please specify the database object for which you are creating this synonym");
        PropertiesTabClicked(null);
        objTbBaseObject.focus();
        return false;
    }
    return true;    
}
