﻿var objViewDesigner = null;
var objTablePleaseWait = null;
var objCellPleaseWaitMessage = null;
var objCbEncryptedView = null;
var objCbSchemaBoundView = null;
var objCbViewReturnsMetadata = null;
var objCbViewWithCheckOption = null;
var objSchema = null;
var objViewName = null;
var objCodePanel = null;
var objSQLPanel = null;
var objCodeTab = null;
var objSQLTab = null;
var mode = "A"; 
var viewMode = "N";

function BodyOnLoad()
{
    objViewDesigner =  document.getElementsByName("tblViewDesigner")[0];
    objTablePleaseWait = document.getElementsByName("tblPleaseWait")[0];
    objCellPleaseWaitMessage = document.getElementsByName("cellPleaseWaitMessage")[0];
    objCodeTab = document.getElementsByName("tabCode")[0];
    objSQLTab = document.getElementsByName("tabSQL")[0];
    objCodePanel = document.getElementsByName("pnlCode")[0];
    objSQLPanel = document.getElementsByName("pnlSQL")[0];
    objSchema = document.form1.ddlSchema;
    objViewName = document.form1.tbViewName;
    objCbEncryptedView = document.form1.cbEncryptedView;
    objCbSchemaBoundView = document.form1.cbSchemaBoundView;
    objCbViewReturnsMetadata = document.form1.cbViewReturnsMetadata;
    objCbViewWithCheckOption = document.form1.cbViewWithCheckOption;
}

function CodeTabClicked(obj)
{
    objSQLTab.className = "itabr";
    objCodeTab.className = "atabr";
    objSQLPanel.style.display = "none";
    objCodePanel.style.display = "block";
}

function SQLTabClicked(obj)
{
    if (ValidateView())
    {
        if (viewMode == "N")
        {
            document.form1.tbSQL.value = "--Preparing view create script, please wait";
            objSQLTab.className = "atabr";
            objCodeTab.className = "itabr";
            objSQLPanel.style.display = "block";
            objCodePanel.style.display = "none";
            Omega.Web.MSSQL.ViewDesigner.BuildCreateViewSQLStatement(trim(objSchema.value), trim(objViewName.value), trim(document.form1.tbCode.value), objCbEncryptedView.checked, objCbSchemaBoundView.checked, objCbViewReturnsMetadata.checked, objCbViewWithCheckOption.checked, BuildCreateOrAlterViewSQLStatement_Callback);
        }
        else
        {
            document.form1.tbSQL.value = "--Preparing view alter script, please wait";
            objSQLTab.className = "atabr";
            objCodeTab.className = "itabr";
            objSQLPanel.style.display = "block";
            objCodePanel.style.display = "none";
            Omega.Web.MSSQL.ViewDesigner.BuildAlterViewSQLStatement(trim(objSchema.value), trim(objViewName.value), trim(document.form1.tbCode.value), objCbEncryptedView.checked, objCbSchemaBoundView.checked, objCbViewReturnsMetadata.checked, objCbViewWithCheckOption.checked, BuildCreateOrAlterViewSQLStatement_Callback);
        }
    }
}

function BuildCreateOrAlterViewSQLStatement_Callback(resp)
{
    tableSQL = resp.value;
    document.form1.tbSQL.value = tableSQL;
    objSQLTab.className = "atabr";
    objCodeTab.className = "itabr";
    objSQLPanel.style.display = "block";
    objCodePanel.style.display = "none";
}

function btnTestSql_OnClick()
{
    if (ValidateView())
    {
        objViewDesigner.style.display = "none";
        objTablePleaseWait.style.display = "block";
        objCellPleaseWaitMessage.innerHTML = checkSqlText;
        Omega.Web.MSSQL.ViewDesigner.ValidateSql(parseInt(document.form1.viewId.value, 10), trim(objSchema.value), trim(objViewName.value), trim(document.form1.tbCode.value), objCbEncryptedView.checked, objCbSchemaBoundView.checked, objCbViewReturnsMetadata.checked, objCbViewWithCheckOption.checked, ValidateSql_Callback);
    }
    return false;
}

function ValidateSql_Callback(resp)
{
    objViewDesigner.style.display = "block";
    objTablePleaseWait.style.display = "none";
    respval = resp.value;
    alert(respval);
}

function btnExecuteSql_OnClick()
{
    if (ValidateView())
    {
        objViewDesigner.style.display = "none";
        objTablePleaseWait.style.display = "block";
        objCellPleaseWaitMessage.innerHTML = savingViewText;
        Omega.Web.MSSQL.ViewDesigner.CreateOrAlterView(parseInt(document.form1.viewId.value, 10), trim(objSchema.value), trim(objViewName.value), trim(document.form1.tbCode.value), objCbEncryptedView.checked, objCbSchemaBoundView.checked, objCbViewReturnsMetadata.checked, objCbViewWithCheckOption.checked, CreateOrAlterView_Callback);
    }
    return false;
}

function CreateOrAlterView_Callback(resp)
{
    respval = resp.value;
    isError = true;
    message = "Unable to update the database";
    if (respval != null)
    {
        respvalarray = respval.split("|");
        message = respvalarray[1];
        if (respval.charAt(0) == "0")
        {
            isError = false;
        }
    }
    alert(message);
    if (isError)
    {
        objViewDesigner.style.display = "block";
        objTablePleaseWait.style.display = "none";
    }
    else
    {
        window.opener.ViewDesignerComplete(viewMode, document.form1.viewId.value, trim(objViewName.value));
        self.close();
    }
}

function ValidateView()
{
    vid = document.form1.viewId.value;
    if (parseInt(vid, 10) > 0)
    {
        viewMode = "E";
    }
    viewName = trim(objViewName.value);
    schemaName = trim(objSchema.value);
    viewCode = trim(document.form1.tbCode.value);
    if (viewName == "")
    {
        alert("View name is a required field");
        objViewName.focus();
        return false;
    }    
    if (viewCode == "")
    {
        alert("View code is a required field");
        document.form1.tbCode.focus();
        return false;
    }
    return true;
}
