﻿var addValueMode = "";
var addValueRowIndex = -1;
function btnSaveAllowedValues_OnClick()
{
    if (addValueMode == "A")
    {
        AddAllowedValues_Save();
    }
    else if (addValueMode == "E")
    {
        EditAllowedValues_Save();
    }
    return false;
}

function EditAllowedValues_Save()
{
    if (! CheckForEnteredAllowedValues()) { return false; }
	var valueValue = trim(document.form1.tbAllowedValue.value);	
	var valueDesc = trim(document.form1.taAllowedValue.value);	

	var valueAllowedValues = document.getElementsByName("vav"); 
	var valueAllowedDescriptions = document.getElementsByName("vad"); 
    var tdValues = document.getElementsByName("tdVal");
    var tdDescs = document.getElementsByName("tdDesc");

    valueAllowedValues[addValueRowIndex].value = valueValue;
    valueAllowedDescriptions[addValueRowIndex].value = valueDesc;
    tdValues[addValueRowIndex].innerText = valueValue;
    tdDescs[addValueRowIndex].innerText = valueDesc;

	document.form1.tbAllowedValue.value = "";
	document.form1.taAllowedValue.value = "";
	
	HidePopups();
    addValueMode = "";
    addValueRowIndex = -1;
	return true;
}

function AddAllowedValues_Save()
{
    if (! CheckForEnteredAllowedValues()) { return false; }

	tableObj = document.getElementsByName("avTable")[0];
	
	var valueValue = trim(document.form1.tbAllowedValue.value);	
	var valueDesc = trim(document.form1.taAllowedValue.value);	
	
	document.form1.tbAllowedValue.value = "";
	document.form1.taAllowedValue.value = "";
	
	cbToAdd = document.createElement("input");
	cbToAdd.type = "checkbox";
	cbToAdd.value = "-1";
	cbToAdd.name = "cba";
	cbToAdd.id = "cba";

	var numRows = document.getElementsByName("cba").length;
	
	vavToAdd = document.createElement("input");
	vavToAdd.type = "hidden";
	vavToAdd.id = "vav";
	vavToAdd.setAttribute("name", "vav");
    vavToAdd.value = valueValue;
    
	vadToAdd = document.createElement("input");
	vadToAdd.type = "hidden";
	vadToAdd.id = "vad";
	vadToAdd.setAttribute("name", "vad");
    vadToAdd.value = valueDesc;
	
	imgFirstA = document.createElement("img");
	imgFirstA.id = "imgFirstA";
	imgFirstA.name = "imgFirstA";
	imgFirstA.src = iPath + "fst.gif";
	moveFirst = "MoveFirstA('" + numRows + "')";

	imgPrevA = document.createElement("img");
	imgPrevA.id = "imgPrevA";
	imgPrevA.name = "imgPrevA";
	imgPrevA.src = iPath + "prv.gif";
	movePrev = "MovePrevA('" + numRows + "')";
	
	imgNextA = document.createElement("img");
	imgNextA.id = "imgNextA";
	imgNextA.name = "imgNextA";
	imgNextA.src = iPath + "nxt.gif";
	moveNext = "MoveNextA('" + numRows + "')";
	
	imgLastA = document.createElement("img");
	imgLastA.id = "imgLastA";
	imgLastA.name = "imgLastA";
	imgLastA.src = iPath + "lst.gif";
	moveLast = "MoveLastA('" + numRows + "')";

	imgEditA = document.createElement("img");
	imgEditA.id = "imgEditA";
	imgEditA.name = "imgEditA";
	imgEditA.src = iPath + "edt.gif";
	editA = "EditA('" + numRows + "')";

	if ( isIE)
	{
		tr = tableObj.insertRow();
		tr.id = "tra";
		tr.setAttribute("name", "tra");
		
		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "left";
		td.className = "chdr";
		td.appendChild(cbToAdd);
		td.appendChild(vavToAdd);
		td.appendChild(vadToAdd);

		td = tr.insertCell();
		td.id = "tdVal";
		td.setAttribute("name", "tdVal");
		td.vAlign = "top";
		td.align = "left";
		td.className = "cdat";
		td.innerText = valueValue;

		td = tr.insertCell();
		td.id = "tdDesc";
		td.setAttribute("name", "tdDesc");
		td.vAlign = "top";
		td.align = "left";
		td.className = "cdat";
		td.innerText = valueDesc;

		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "center";
		td.className = "cdat";
		imgFirstA.onclick = function () { MoveFirstA()};
		imgPrevA.onclick = function () { MovePrevA()};
		imgNextA.onclick = function () { MoveNextA()};
		imgLastA.onclick = function () { MoveLastA()};
		td.appendChild(imgFirstA);
		td.appendChild(imgPrevA);
		td.appendChild(imgNextA);
		td.appendChild(imgLastA);

		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "center";
		td.className = "cdat";
		imgEditA.onclick = function () { EditA()};
		td.appendChild(imgEditA);
	}
	else
	{
		imgFirstA.setAttribute("OnClick", moveFirst);
		imgNextA.setAttribute("OnClick", moveNext);
		imgPrevA.setAttribute("OnClick", movePrev);
		imgLastA.setAttribute("OnClick", moveLast);
		imgEditA.setAttribute("OnClick", editA);

		tr = document.createElement("tr");
		tr.id = "tra";
		tr.setAttribute("name", "tra");

		td = document.createElement("td");
		td.vAlign = "top";
		td.align = "center";
		td.className = "chdr";
		td.appendChild(cbToAdd);
		td.appendChild(vavToAdd);
		td.appendChild(vadToAdd);
		tr.appendChild(td);

		td = document.createElement("td");
		td.id = "tdVal";
		td.setAttribute("name", "tdVal");
		td.vAlign = "top";
		td.align = "center";
		td.className = "cdat";
		td.innerText = valueValue;
		tr.appendChild(td);

		td = document.createElement("td");
		td.id = "tdDesc";
		td.setAttribute("name", "tdDesc");
		td.vAlign = "top";
		td.align = "center";
		td.className = "cdat";
		td.innerText = valueDesc;
		tr.appendChild(td);

		td = document.createElement("td");
		td.vAlign = "top";
		td.align = "center";
		td.className = "cdat";
		td.appendChild(imgFirstA);
		td.appendChild(imgPrevA);
		td.appendChild(imgNextA);
		td.appendChild(imgLastA);
		tr.appendChild(td);

		td = document.createElement("td");
		td.vAlign = "top";
		td.align = "center";
		td.className = "cdat";
		td.appendChild(imgEditA);
		tr.appendChild(td);

		tableObj.appendChild(tr);			
	}
	document.form1.tbAllowedValue.focus();
    addValueMode = "A";
    addValueRowIndex = -1;
	return false;
}
function btnAddAllowedValues_OnClick()
{
    addValueMode = "A";
    document.form1.ddlRangeLogicalOperator.selectedIndex = 0;
    document.form1.tbValueFrom.value = "";
    document.form1.tbValueTo.value = "";
    document.form1.taRangeValueDesc.value = "";
    document.form1.tbAllowedValue.value = "";
    document.form1.taAllowedValue.value = "";
    window.setTimeout("btnAddEditAllowedValues_OnClick()", 10);
    return false;
}

function btnAddEditAllowedValues_OnClick()
{
    divAllowedValues.style.display = "block";
    CenterIt(divAllowedValues);
    document.form1.tbAllowedValue.focus();
    return false;
}

function btnDeleteAllowedValues_OnClick()
{
	tableObj = document.getElementsByName("avTable")[0];
	var checkBoxes = document.getElementsByName("cba");
	var numRows = checkBoxes.length;
	var areRowsDeleted = false;
	for (var i=numRows-1; i>=0; i--)
	{
		if (checkBoxes[i].checked)
		{
			if (isIE) { tableObj.deleteRow(i+1); }
			else { deletedRow = tableObj.removeChild(document.getElementsByName("tra")[i]); }
			areRowsDeleted = true;
		}
	}
	if (areRowsDeleted)
	{
		var imgFirstAs = document.getElementsByName("imgFirstA");
		var imgPrevAs = document.getElementsByName("imgPrevA");
		var imgNextAs = document.getElementsByName("imgNextA");
		var imgLastAs = document.getElementsByName("imgLastA");
		var imgEditAs = document.getElementsByName("imgEditA");
		numRows = imgLastAs.length;
		for (var i=0; i<numRows; i++)
		{
			if (! isIE)
			{
				moveFirst = "MoveFirstA('" + i + "')";
				movePrev = "MovePrevA('" + i + "')";
				moveNext = "MoveNextA('" + i + "')";
				moveLast = "MoveLastA('" + i + "')";
				edit = "EditA('" + i + "')";
				imgFirstAs[i].setAttribute("OnClick", moveFirst, 0);
				imgNextAs[i].setAttribute("OnClick", moveNext, 0);
				imgPrevAs[i].setAttribute("OnClick", movePrev, 0);
				imgLastAs[i].setAttribute("OnClick", moveLast, 0);
				imgEditAs[i].setAttribute("OnClick", edit, 0);
			}	
		}
	}
	return false;
}
function EditA(pos)
{
	if (isIE)
	{
		obj = event.srcElement;
		parentRow = obj.parentElement.parentElement;
		pos = parentRow.rowIndex - 1;
	}
	position = parseInt(pos, 10);
	var valueAllowedValues = document.getElementsByName("vav"); 
	var valueAllowedDescriptions = document.getElementsByName("vad"); 
	val = valueAllowedValues[position].value;
	desc = valueAllowedDescriptions[position].value;
	document.form1.tbAllowedValue.value = val;
	document.form1.taAllowedValue.value = desc;	
    addValueMode = "E";
    addValueRowIndex = position;
    window.setTimeout("btnAddEditAllowedValues_OnClick()", 10);
}
function MoveFirstA(pos)
{
	if (isIE)
	{
		obj = event.srcElement;
		parentRow = obj.parentElement.parentElement;
		pos = parentRow.rowIndex - 1;
	}
	position = parseInt(pos, 10);
	numRows = parseInt(document.getElementsByName("cba").length, 10);
	if (position <= 0 || numRows <= 1) { return; }
	var checkBoxes = document.getElementsByName("cba");
	var valueAllowedValues = document.getElementsByName("vav"); 
	var valueAllowedDescriptions = document.getElementsByName("vad"); 
    var tdValues = document.getElementsByName("tdVal");
    var tdDescs = document.getElementsByName("tdDesc");
	var cbValueAtPosition = checkBoxes[position].value;
	var avvValueAtPosition = valueAllowedValues[position].value;
	var avdValueAtPosition = valueAllowedDescriptions[position].value;
	
	var cbValueAtNextPosition = "";
	var tbValueAtNextPosition = "";
	var taValueAtNextPosition = "";
	for (var i=0; i<=position; i++)
	{
		cbValueAtNextPosition = checkBoxes[i].value;
		avvValueAtNextPosition = valueAllowedValues[i].value;
		avdValueAtNextPosition = valueAllowedDescriptions[i].value;
		
		checkBoxes[i].value = cbValueAtPosition;
		valueAllowedValues[i].value = avvValueAtPosition;
		valueAllowedDescriptions[i].value = avdValueAtPosition;
		tdValues[i].innerText = avvValueAtPosition;
		tdDescs[i].innerText = avdValueAtPosition;
		cbValueAtPosition = cbValueAtNextPosition;
		avvValueAtPosition = avvValueAtNextPosition;
		avdValueAtPosition = avdValueAtNextPosition;
		
	}
	return false;
}

function MovePrevA(pos)
{
	if (isIE)
	{
		obj = event.srcElement;
		parentRow = obj.parentElement.parentElement;
		pos = parentRow.rowIndex - 1;
	}
	var position = parseInt(pos, 10);
	var numRows = parseInt(document.getElementsByName("cba").length, 10);
	var prevRowIndex = position - 1;
	if (position <= 0 || numRows <= 1) { return; }
	var checkBoxes = document.getElementsByName("cba");
	var valueAllowedValues = document.getElementsByName("vav"); 
	var valueAllowedDescriptions = document.getElementsByName("vad"); 
    var tdValues = document.getElementsByName("tdVal");
    var tdDescs = document.getElementsByName("tdDesc");

	var cbValueAtPosition = checkBoxes[position].value;
	var vavValueAtPosition = valueAllowedValues[position].value;
	var vadValueAtPosition = valueAllowedDescriptions[position].value;
	
	checkBoxes[position].value = checkBoxes[prevRowIndex].value;
	valueAllowedValues[position].value = valueAllowedValues[prevRowIndex].value;
	valueAllowedDescriptions[position].value = valueAllowedDescriptions[prevRowIndex].value;
	tdValues[position].innerText = valueAllowedValues[position].value;
	tdDescs[position].innerText = valueAllowedDescriptions[position].value;

	checkBoxes[prevRowIndex].value = cbValueAtPosition;
	valueAllowedValues[prevRowIndex].value = vavValueAtPosition;
	valueAllowedDescriptions[prevRowIndex].value = vadValueAtPosition;
	tdValues[prevRowIndex].innerText = vavValueAtPosition;
	tdDescs[prevRowIndex].innerText = vadValueAtPosition;
	return false;

}
function MoveNextA(pos)
{
	if (isIE)
	{
		obj = event.srcElement;
		parentRow = obj.parentElement.parentElement;
		pos = parentRow.rowIndex - 1;
	}
	var position = parseInt(pos, 10);
	var numRows = parseInt(document.getElementsByName("cba").length, 10);
	var nextRowIndex = position + 1;
	if (position >= numRows-1 || numRows <= 1) { return; }
	var checkBoxes = document.getElementsByName("cba");
	var valueAllowedValues = document.getElementsByName("vav"); 
	var valueAllowedDescriptions = document.getElementsByName("vad"); 
    var tdValues = document.getElementsByName("tdVal");
    var tdDescs = document.getElementsByName("tdDesc");

	var cbValueAtPosition = checkBoxes[position].value;
	var vavValueAtPosition = valueAllowedValues[position].value;
	var vadValueAtPosition = valueAllowedDescriptions[position].value;
	
	checkBoxes[position].value = checkBoxes[nextRowIndex].value;
	valueAllowedValues[position].value = valueAllowedValues[nextRowIndex].value;
	valueAllowedDescriptions[position].value = valueAllowedDescriptions[nextRowIndex].value;
	tdValues[position].innerText = valueAllowedValues[position].value;
	tdDescs[position].innerText = valueAllowedDescriptions[position].value;
	
	checkBoxes[nextRowIndex].value = cbValueAtPosition;
	valueAllowedValues[nextRowIndex].value = vavValueAtPosition;
	valueAllowedDescriptions[nextRowIndex].value = vadValueAtPosition;
	tdValues[nextRowIndex].innerText = vavValueAtPosition;
	tdDescs[nextRowIndex].innerText = vadValueAtPosition;
	
	return false;
}

function MoveLastA(pos)
{
	if (isIE)
	{
		obj = event.srcElement;
		parentRow = obj.parentElement.parentElement;
		pos = parentRow.rowIndex - 1;
	}
	position = parseInt(pos, 10);
	numRows = parseInt(document.getElementsByName("cba").length, 10);
	if (position >= numRows-1 || numRows <= 1) { return; }
	var checkBoxes = document.getElementsByName("cba");
	var valueAllowedValues = document.getElementsByName("vav"); 
	var valueAllowedDescriptions = document.getElementsByName("vad"); 
    var tdValues = document.getElementsByName("tdVal");
    var tdDescs = document.getElementsByName("tdDesc");

	var cbValueAtPosition = checkBoxes[position].value;
	var vavValueAtPosition = valueAllowedValues[position].value;
	var vadValueAtPosition = valueAllowedDescriptions[position].value;
	
	var cbValueAtNextPosition = "";
	var vavValueAtNextPosition = "";
	var vadValueAtNextPosition = "";
	for (var i=numRows-1; i>=position; i--)
	{
		cbValueAtNextPosition = checkBoxes[i].value;
		vavValueAtNextPosition = valueAllowedValues[i].value;
		vadValueAtNextPosition = valueAllowedDescriptions[i].value;
		
		checkBoxes[i].value = cbValueAtPosition;
		valueAllowedValues[i].value = vavValueAtPosition;
		valueAllowedDescriptions[i].value = vadValueAtPosition;
		tdValues[i].innerText = vavValueAtPosition;
		tdDescs[i].innerText = vadValueAtPosition;
		
		cbValueAtPosition = cbValueAtNextPosition;
		vavValueAtPosition = vavValueAtNextPosition;
		vadValueAtPosition = vadValueAtNextPosition;
	}
	return false;
}

function CheckForEnteredAllowedValues()
{
	var valueValue = trim(document.form1.tbAllowedValue.value);	
	var valueDesc = trim(document.form1.taAllowedValue.value);	
	if (valueValue == "") { alert("Value can not be empty"); document.form1.tbAllowedValue.focus(); return false;}
	if (valueDesc == "") { alert("Value description can not be empty"); document.form1.taAllowedValue.focus();  return false;}
	if (valueDesc.length > parseInt(MaxCommentsSize2, 10)) { alert("Value description can not be more than " + MaxCommentsSize2 + " characters long"); document.form1.taAllowedValue.select();  return false;}
	//now check for duplicate
	var valueAllowedValues = document.getElementsByName("vav"); 
    for (var i=0; i<valueAllowedValues.length; i++)
    {
        if (valueAllowedValues[i].value == valueValue && i != addValueRowIndex)
        {
            alert("A duplicate entry found in row # " + parseInt(i+1, 10) + ". Duplicate values are not allowed");
            document.form1.tbAllowedValue.select();
            return false;
        }
    }	
	return true;
}

function ValidateAllowedValues()
{
	var valueAllowedValues = document.getElementsByName("vav"); 
	if (valueAllowedValues.length <= 0)
	{
	    alert("There should be at least one row of allowed values for this column");
	    return false;
	}
	return true;
}
