﻿var selectClauses = new Array();
var divSelectPanel = null;
var ddlSelectCol = null;
var btnSelectFn = null;
var tbSelectAlias = null;
var cbSelectOutputCol = null;
var ddlSelectOrderBy = null;
var ddlSelectGrpByFn = null;
var cbSelectGrpBy = null;
var hidSelectRowNum = null;
var btnSelectSave = null;
function InitializeSelectPanel()
{
    divSelectPanel = document.getElementsByName("pnlAddEditSelectClause")[0];
    ddlSelectCol = document.getElementsByName("ddlcolaesc")[0];
    btnSelectFn = document.getElementsByName("btnfncaesc")[0];
    tbSelectAlias = document.getElementsByName("tbaliasaesc")[0];
    cbSelectOutputCol = document.getElementsByName("cboutputaesc")[0];
    ddlSelectOrderBy = document.getElementsByName("ddlorderbyaesc")[0];
    ddlSelectGrpByFn = document.getElementsByName("ddlgrpfaesc")[0];
    cbSelectGrpBy = document.getElementsByName("cbgroupbyaesc")[0];
    hidSelectRowNum = document.getElementsByName("aescrownum")[0];
    btnSelectSave = document.getElementsByName("btnsaveaesc")[0];
}

function SelectClause(columnName, columnAlias, isOutput, sortOrder, groupingFunction, isGroupBy)
{
    if (columnName.indexOf(".*") >= 0 && trim(groupingFunction) == "")
    {
        columnAlias = "";
    }
    this.columnName = columnName;
    this.columnAlias = columnAlias;
    this.isOutput = isOutput;
    this.sortOrder = sortOrder;
    this.groupingFunction = groupingFunction;
    this.isGroupBy = isGroupBy;
    if (groupingFunction == "")
    {
        this.selectColumnDisplayText = columnName;
    }
    else
    {
        if (groupingFunction.toUpperCase().indexOf(" DISTINCT") > 0)
        {
            groupingFunctionArray = groupingFunction.split(" ");
            tmpGroupString = "";
            for (var i=0; i<groupingFunctionArray.length-1; i++)
            {
                tmpGroupString += groupingFunctionArray[i] + " ";
            }
            this.selectColumnDisplayText = trim(tmpGroupString) + "(" + groupingFunctionArray[length] + " " + columnName + ")";
        }
        else
        {
            this.selectColumnDisplayText = groupingFunction + "(" + columnName + ")";
        }
    }
    if (columnAlias != "")
    {
        this.selectColumnDisplayText += " AS " + columnAlias;
    }
}

function BuildAllSelectClauses()
{
    var allSelectClauses = new Array();
    if (selectClauses.length > 0)
    {
        for (var i=0; i<selectClauses.length; i++)
        {
            if (selectClauses[i].isOutput)
            {
                allSelectClauses[allSelectClauses.length] = selectClauses[i].selectColumnDisplayText;
                //if (i < selectClauses.length-1) { allSelectClauses += ",\n\t\t"; }
            }    
        }
    }
    return allSelectClauses.join(",\n\t\t");
}

function BuildAllOrderByClauses()
{
    var allOrderByClauses = "";
    if (selectClauses.length > 0)
    {
        for (var i=0; i<selectClauses.length; i++)
        {
            if (selectClauses[i].sortOrder != "")
            {
                allOrderByClauses += selectClauses[i].selectColumnDisplayText + " " + selectClauses[i].sortOrder;
                if (i < selectClauses.length-1) { allOrderByClauses += ", "; }
            }    
        }
    }
    return allOrderByClauses;
}
function RepopulateSelectColumnRows()
{
    
    var tmpColumnNamesListForSelect = new Array();
    for (var i=0; i<dbColumns.length; i++)
    {
        tmpColumnNamesListForSelect[tmpColumnNamesListForSelect.length] = dbColumns[i].columnDisplayName;
    }
    thisDropDownList = ddlSelectCol;
    thisDropDownListValue = thisDropDownList.value;
    FillDropDownList(thisDropDownList, thisDropDownListValue, tmpColumnNamesListForSelect, tmpColumnNamesListForSelect, true);

}

function CheckForDuplicateSelectClauses(thisSelectClause, rowToIgnore)
{
    for (var i=0; i<selectClauses.length; i++)
    {
        if (i != rowToIgnore)
        {
            selectClauseToCompareTo = selectClauses[i];
            if (selectClauseToCompareTo.columnName == thisSelectClause.columnName && selectClauseToCompareTo.isOutput == thisSelectClause.isOutput && selectClauseToCompareTo.groupingFunction == thisSelectClause.groupingFunction && selectClauseToCompareTo.isGroupBy == thisSelectClause.isGroupBy)
            {
                alert("Duplicate select clause found. Please refer to row number " + (i+1) + " for duplication");   
                return true;
            }
            if ((selectClauseToCompareTo.columnAlias == thisSelectClause.columnAlias) && (thisSelectClause.columnAlias != ""))
            {
                alert("Duplicate column aliases found in the select clause. Please refer to row number " + (i+1) + " for duplication");   
                return true;
            }
        }
    }
    return false;
}

function btnAddSelect_OnClick()
{
    if (dbColumns.length == 0) { alert("Please select some tables first"); ReplicateBodyOnLoad(); return false;}
    
    var tmpColumnNamesListForSelect = new Array();
    for (var i=0; i<dbColumns.length; i++)
    {
        tmpColumnNamesListForSelect[tmpColumnNamesListForSelect.length] = dbColumns[i].columnDisplayName;
    }
    
    FillDropDownList(ddlSelectCol, "", tmpColumnNamesListForSelect, tmpColumnNamesListForSelect, true);
    ddlcolaesc_OnChange(ddlSelectCol);
    cbSelectOutputCol.checked = true;
    ShowPopups_AddEditSelectClause();
}

function ShowPopups_AddEditSelectClause()
{
    divSelectPanel.style.display = "block";
    CenterIt(divSelectPanel);
    ddlSelectCol.focus();
}

function HidePopups_AddEditSelectClause()
{
    btnSelectFn.disabled = true;
    tbSelectAlias.value = "";
    tbSelectAlias.disabled = true;
    cbSelectOutputCol.checked = false;
    cbSelectOutputCol.disabled = true;
    ddlSelectOrderBy.selectedIndex = 0;
    ddlSelectOrderBy.disabled = true;
    ddlSelectGrpByFn.disabled = true;
    cbSelectGrpBy.checked = false;
    cbSelectGrpBy.disabled = true;
    btnSelectSave.disabled = true;
    ddlSelectGrpByFn.options.length = 0;
    hidSelectRowNum.value = "-1";
    divSelectPanel.style.display = "none";
    HidePopups_AddFunction();
}

function ddlcolaesc_OnChange(obj)
{
    btnSelectFn.disabled = false;
    tbSelectAlias.disabled = false;
    cbSelectOutputCol.disabled = false;
    ddlSelectOrderBy.disabled = false;
    ddlSelectGrpByFn.disabled = false;
    cbSelectGrpBy.disabled = false;
    btnSelectSave.disabled = false;
    ddlSelectGrpByFn.options.length = 0;
    arrayToUse = new Array();
    if (dbColumns[obj.selectedIndex].isColumnNumeric)
    {
        arrayToUse = groupingFunctionsNumericColumns;
    }
    if (dbColumns[obj.selectedIndex].isColumnNonNumeric)
    {
        arrayToUse = groupingFunctionsNonNumericColumns;
    }
    if (dbColumns[obj.selectedIndex].isAllColumns)
    {
        arrayToUse = groupingFunctionsAllColumns;
        ddlSelectOrderBy.disabled = true;//can't define sorting on all columns
        btnSelectFn.disabled = true;//can't define a function on all columns
        cbSelectGrpBy.disabled = true;//can't do a group by on all columns
    }
    FillDropDownList(ddlSelectGrpByFn, "", arrayToUse, arrayToUse, true);
}

function btnfncaesc_OnClick(obj)
{
    columnNamesList = columnNamesListForSelect;
    ShowPopups_AddFunction("ddlcolaesc", obj, "btnfncaesc", 0);
}

function ddlgrpfaesc_OnChange(obj)
{
    groupByCheckBox = cbSelectGrpBy;
    if (obj.selectedIndex == 0 || trim(obj.value) == "")
    {
        groupByCheckBox.disabled = false;
    }
    else
    {
        groupByCheckBox.checked = false;
        groupByCheckBox.disabled = true;
    }
    return false;
}

function btnsaveaesc_OnClick()
{
    rowNumber = parseInt(hidSelectRowNum.value, 10);
    isNewRow = hidSelectRowNum.value == "-1";
    if (isNewRow)
    {
        tempSelectClause = new SelectClause(ddlSelectCol.value, trim(tbSelectAlias.value), (cbSelectOutputCol.checked==true), trim(ddlSelectOrderBy.value), trim(ddlSelectGrpByFn.value), (cbSelectGrpBy.checked==true));
        if (! CheckForDuplicateSelectClauses(tempSelectClause, -1))
        {
            selectClauses[selectClauses.length] = tempSelectClause;
            AddNewSelectRow();        
        }
    }
    else
    {
        tempSelectClause = new SelectClause(ddlSelectCol.value, trim(tbSelectAlias.value), (cbSelectOutputCol.checked==true), trim(ddlSelectOrderBy.value), trim(ddlSelectGrpByFn.value), (cbSelectGrpBy.checked==true));
        if (! CheckForDuplicateSelectClauses(tempSelectClause, rowNumber))
        {
            selectClauses[rowNumber] = tempSelectClause;
            EditSelectRow(rowNumber);        
        }
    }
    HidePopups_AddEditSelectClause();
    return false;
}

function btncancelaesc_OnClick()
{
    HidePopups_AddEditSelectClause();
    return false;
}

function EditSelectRow(rowNum)
{
    thisSelectClause = selectClauses[rowNum];

    cb1Text = "<input type=\"checkbox\" style=\"width: 15px; height: 15px\" disabled>";
    if (thisSelectClause.isOutput == true)
    {
        cb1Text = "<input checked type=\"checkbox\" style=\"width: 15px; height: 15px\" disabled>";
    }
    cb2Text = "<input type=\"checkbox\" style=\"width: 15px; height: 15px\" disabled>";
    if (thisSelectClause.isGroupBy == true)
    {
        cb2Text = "<input checked type=\"checkbox\" style=\"width: 15px; height: 15px\" disabled>";
    }
    document.getElementsByName("setd1")[rowNum].innerText = thisSelectClause.selectColumnDisplayText;
    document.getElementsByName("setd2")[rowNum].innerHTML = cb1Text;
    document.getElementsByName("setd3")[rowNum].innerText = thisSelectClause.sortOrder;
    document.getElementsByName("setd4")[rowNum].innerHTML = cb2Text;
    return false;
}

function AddNewSelectRow()
{
    thisSelectClause = selectClauses[selectClauses.length-1];
    
    btnf2 = document.createElement("input");
    btnf2.type = "button";
    btnf2.className = "btns";
    btnf2.value = "E";
    btnf2.style.cssText = "width: 16px; height: 16px;";
    btnf2.id = "btnedsc";
    btnf2.setAttribute("name", "btnedsc");
    btnf2.setAttribute("title", "Click here to edit this select clause");
        
    bd = document.createElement("input");
    bd.type = "button";
    bd.className = "btns";
    bd.value = "X";
    bd.style.cssText = "width: 16px; height: 16px;";
    bd.id = "delsec";
    bd.setAttribute("name", "delsec");
    bd.setAttribute("title", "Click here to delete this select clause");

    cb1Text = "<input type=\"checkbox\" style=\"width: 15px; height: 15px\" disabled>";
    if (thisSelectClause.isOutput == true)
    {
        cb1Text = "<input checked type=\"checkbox\" style=\"width: 15px; height: 15px\" disabled>";
    }
    cb2Text = "<input type=\"checkbox\" style=\"width: 15px; height: 15px\" disabled>";
    if (thisSelectClause.isGroupBy == true)
    {
        cb2Text = "<input checked type=\"checkbox\" style=\"width: 15px; height: 15px\" disabled>";
    }

    if (isIE)
    {
        btnf2.onclick = function () { btnEditSelectRow_OnClick() };
        bd.onclick = function () { btnDeleteSelectRow_OnClick() };        

        tr = selectTable.insertRow();
        tr.id = "ser";
        tr.setAttribute("name", "ser");

		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(btnf2);

		td = tr.insertCell();
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(bd);

		td = tr.insertCell();
        td.id = "setd1";
        td.setAttribute("name", "setd1");
		td.vAlign = "top";
		td.align = "left";
		td.className = "fes";
		td.innerText = thisSelectClause.selectColumnDisplayText;

		td = tr.insertCell();
        td.id = "setd2";
        td.setAttribute("name", "setd2");
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerHTML = cb1Text;

		td = tr.insertCell();
        td.id = "setd3";
        td.setAttribute("name", "setd3");
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerText = thisSelectClause.sortOrder;

		td = tr.insertCell();
        td.id = "setd4";
        td.setAttribute("name", "setd4");
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerHTML = cb2Text;
    }
    else
    {
        btnf2.setAttribute("onClick", "btnEditSelectRow_OnClick(this)");
        bd.setAttribute("onclick", "btnDeleteSelectRow_OnClick(this)");
        
		tr = document.createElement("tr");
        tr.id = "ser";
        tr.setAttribute("name", "ser");

		td = document.createElement("td");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(btnf2);

		td = document.createElement("td");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.width = "25";
		td.appendChild(bd);

		td = document.createElement("td");
		tr.appendChild(td);
        td.id = "setd1";
        td.setAttribute("name", "setd1");
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerText = thisSelectClause.selectColumnDisplayText;

		td = document.createElement("td");
		tr.appendChild(td);
        td.id = "setd2";
        td.setAttribute("name", "setd2");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerHTML = cb1Text;

		td = document.createElement("td");
		tr.appendChild(td);
        td.id = "setd3";
        td.setAttribute("name", "setd3");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerText = thisSelectClause.sortOrder;

		td = document.createElement("td");
		tr.appendChild(td);
        td.id = "setd4";
        td.setAttribute("name", "setd4");
		tr.appendChild(td);
		td.vAlign = "top";
		td.align = "center";
		td.className = "fes";
		td.innerHTML = cb2Text;
		
		selectTable.appendChild(tr);	
		
    }  
    return false;
}

function btnDeleteSelectRow_OnClick(obj)
{
    if (isIE)
    {
        rowIndex = event.srcElement.parentElement.parentElement.rowIndex - 1;
        selectTable.deleteRow(rowIndex+1);
    }
    else
    {
        for (var i=0; i<document.getElementsByName("delsec").length; i++)
        {
            if (document.getElementsByName("delsec")[i] == obj)
            {
                rowIndex = i;
                selectTable.removeChild(document.getElementsByName("ser")[i]);
                break;
            }
        }
    }
    selectClauses = DeleteArrayElement(selectClauses, rowIndex);
}

function btnEditSelectRow_OnClick(obj)
{
    rowIndex = -1;
    if (isIE)
    {
        rowIndex = event.srcElement.parentElement.parentElement.rowIndex - 1;
    }
    else
    {
        for (var i=0; i<document.getElementsByName("btnedsc").length; i++)
        {
            if (document.getElementsByName("btnedsc")[i] == obj)
            {
                rowIndex = i;
                break;
            }
        }
    }
    if (rowIndex > -1)
    {
        thisSelectClause = selectClauses[rowIndex];
        var tmpColumnNamesListForSelect = new Array();
        for (var i=0; i<dbColumns.length; i++)
        {
            if (thisSelectClause.columnName.toUpperCase().indexOf(dbColumns[i].columnDisplayName.toUpperCase()) >= 0)
            {
                tmpColumnNamesListForSelect[tmpColumnNamesListForSelect.length] = thisSelectClause.columnName;
            }
            else
            {
                tmpColumnNamesListForSelect[tmpColumnNamesListForSelect.length] = dbColumns[i].columnDisplayName;
            }    
        }
        FillDropDownList(ddlSelectCol, thisSelectClause.columnName, tmpColumnNamesListForSelect, tmpColumnNamesListForSelect, true);
        ddlcolaesc_OnChange(ddlSelectCol);
        hidSelectRowNum.value = rowIndex;
        btnSelectFn.disabled = false;
        tbSelectAlias.disabled = false;
        tbSelectAlias.value = thisSelectClause.columnAlias;
        cbSelectOutputCol.disabled = false;
        cbSelectOutputCol.checked = (thisSelectClause.isOutput == true); 
        ddlSelectOrderBy.disabled = false;
        ddlSelectOrderBy.value = thisSelectClause.sortOrder;
        ddlSelectGrpByFn.disabled = false;
        ddlSelectGrpByFn.value = thisSelectClause.groupingFunction;
        if (thisSelectClause.columnName.indexOf(".*") >= 0)
        {
            btnSelectFn.disabled = true;
        }
        if (thisSelectClause.groupingFunction != "")
        {
            cbSelectGrpBy.disabled = true;
            cbSelectGrpBy.checked = false;
        }
        else
        {
            cbSelectGrpBy.checked = (thisSelectClause.isGroupBy == true);
        }
        btnSelectSave.disabled = false;
        ShowPopups_AddEditSelectClause();
    }
}

function DeleteAllSelectRows()
{
    numSelectRows = document.getElementsByName("ser").length;
    for (var i=numSelectRows-1; i>=0; i--)
    {
        if (isIE)
        {
            selectTable.deleteRow(i+1);  
        }
        else
        {
            selectTable.removeChild(document.getElementsByName("ser")[i]);
        }
    }
    selectClauses = new Array();
}

function DeleteSelectRowsContainingTable(tableAlias)
{
    tableAlias += ".";
    //tableName = tableName + ".";
    for (var i=selectClauses.length-1; i>=0; i--)
    {
        if (selectClauses[i].columnName.toUpperCase().indexOf(tableAlias.toUpperCase()) >= 0)
        {
            selectClauses = DeleteArrayElement(selectClauses, i);
            if (isIE)
            {
                selectTable.deleteRow(i+1);  
            }
            else
            {
                selectTable.removeChild(document.getElementsByName("ser")[i]);
            }
        }
    }
}

function jsCheckForSelectColumns()
{
    var selectTab = document.getElementsByName("Columns")[0];
    if (selectClauses.length == 0) { alert("Please select at least one column"); TabClicked2(selectTab); return false; }//one column must be selected
    var isThereAnyOutputClause = false;
    for (var i=0; i<selectClauses.length; i++)
    {
        if (selectClauses[i].isOutput)
        {
            isThereAnyOutputClause = true;
            break;
        }
    }
    if (! isThereAnyOutputClause ) { alert("There should be at least one output column"); TabClicked2(selectTab); return false; }
    return true;    
}