﻿var objTableDesigner = null;
var objCbWriteOwnSQL = null;
var objTablePleaseWait = null;
var objCellPleaseWaitMessage = null;
var objSchema = null;
var objTableName = null;
var objTableFileGroup = null;
var objTextFileGroup = null;
var objColumnsPanel = null;
var objSQLPanel = null;
var objColumnsTab = null;
var objSQLTab = null;
var objAddEditColumnPanel = null;
var objColumnsTable = null;
var objColumnName = null;
var objColumnDataType = null;
var objLength = null;
var objPrecision = null;
var objScale = null;
var objIsPrimaryKey = null;
var objIsIdentityCol = null;
var objIdentitySeed = null;
var objIdentityIncrement = null;
var objNullAllowed = null;
var objIsRowGuid = null;
var objTbDefault = null;
var objDdlDefault = null;
var objDdlRule = null;
var objCollation = null;
var objTbComputedColumn = null;
var mode = "A"; 
var tableMode = "N";

function BodyOnLoad()
{
    try
    {
        objTableDesigner = document.getElementsByName("tblTableDesigner")[0];
        objCbWriteOwnSQL = document.form1.cbWriteOwnSQL;
        objTablePleaseWait = document.getElementsByName("tblPleaseWait")[0];
        objCellPleaseWaitMessage = document.getElementsByName("cellPleaseWaitMessage")[0];
        objSchema = document.form1.ddlSchema;
        objTableName = document.form1.tbTableName;
        objTableFileGroup = document.form1.ddlTableFileGroup;
        objTextFileGroup = document.form1.ddlTextFileGroup;
        objColumnsTable = document.getElementsByName("tblColumns")[0];
        objColumnsPanel = document.getElementsByName("pnlColumns")[0];
        objSQLPanel = document.getElementsByName("pnlSQL")[0];
        objColumnsTab = document.getElementsByName("tabColumns")[0];
        objSQLTab = document.getElementsByName("tabSQL")[0];
        InitColumnsPanel();
        if (columns != null && columns.length > 0)
        {
            for (var i=0; i<columns.length; i++)
            {
                PaintNewColumnRow(columns[i], i);
            }
        }
    }
    catch (e)
    {
    }
}

function ColumnsClicked(obj)
{
    objSQLTab.className = "itabr";
    objColumnsTab.className = "atabr";
    objSQLPanel.style.display = "none";
    objColumnsPanel.style.display = "block";
}

function SQLTabClicked(obj)
{
    HideAddEditColumnPanel();
    if (objCbWriteOwnSQL.checked)
    {
        objSQLTab.className = "atabr";
        objColumnsTab.className = "itabr";
        objSQLPanel.style.display = "block";
        objColumnsPanel.style.display = "none";
        document.form1.tbSQL.focus();
    }
    else
    {
        if (ValidateTable())
        {
            if (tableMode == "N")
            {
                document.form1.tbSQL.value = "--Preparing table create script, please wait";
                objSQLTab.className = "atabr";
                objColumnsTab.className = "itabr";
                objSQLPanel.style.display = "block";
                objColumnsPanel.style.display = "none";
                Omega.Web.MSSQL.TableDesigner.BuildCreateTableSQLStatement(trim(objSchema.value), trim(objTableName.value), trim(objTableFileGroup.value), trim(objTextFileGroup.value), columns, dataTypes, BuildCreateOrAlterTableSQLStatement_Callback)
            }
            else
            {
                document.form1.tbSQL.value = "--Preparing table alter script, please wait";
                objSQLTab.className = "atabr";
                objColumnsTab.className = "itabr";
                objSQLPanel.style.display = "block";
                objColumnsPanel.style.display = "none";
                Omega.Web.MSSQL.TableDesigner.BuildAlterTableSQLStatement(trim(objSchema.value), trim(objTableName.value), trim(objTableFileGroup.value), trim(objTextFileGroup.value), columns, oldColumns, dataTypes, referenceKeys, indexes, BuildCreateOrAlterTableSQLStatement_Callback)
            }
        }
    }
}

function BuildCreateOrAlterTableSQLStatement_Callback(resp)
{
    tableSQL = resp.value;
    document.form1.tbSQL.value = tableSQL;
    objSQLTab.className = "atabr";
    objColumnsTab.className = "itabr";
    objSQLPanel.style.display = "block";
    objColumnsPanel.style.display = "none";
}

function ValidateTable()
{
    tid = document.form1.tableId.value;
    if (parseInt(tid, 10) > 0)
    {
        tableMode = "E";
    }
    tableName = trim(objTableName.value);
    schemaName = trim(objSchema.value);
    if (tableName == "")
    {
        alert("Table name is a required field");
        objTableName.focus();
        return false;
    }    
    if (columns.length <= 0)
    {
        alert("Please specify at least one column for this table");
        ColumnsClicked(null);
        return false;
    }
    var allColumnsDeleted = true;
    for (var i=0; i<columns.length; i++)
    {
        if (! columns[i].isColumnDeleted)
        {
           allColumnsDeleted = false;
           break; 
        }
    }     
    if (allColumnsDeleted)
    {
        alert("Please specify at least one column for this table");
        ColumnsClicked(null);
        return false;
    }
    return true;
}

function IsDefaultSystemDefault(defaultValue)
{
    var isDefaultSystemDefault = false;
    for (var j=0; j<defaults.length; j++)
    {
        if (defaults[j] == defaultValue)
        {
            isDefaultSystemDefault = true;
            break;    
        }
    }
    return isDefaultSystemDefault;
}

function btnTestSql_OnClick()
{
    HideAddEditColumnPanel();
    if (objCbWriteOwnSQL.checked)
    {
        document.form1.tbSQL.value = trim(document.form1.tbSQL.value);
        if (document.form1.tbSQL.value == "")
        {
            alert("There is no SQL to validate.");
            SQLTabClicked(null);
            document.form1.tbSQL.focus();
        }
        else
        {
            objTableDesigner.style.display = "none";
            objTablePleaseWait.style.display = "block";
            objCellPleaseWaitMessage.innerHTML = checkSqlText;
            Omega.Web.MSSQL.TableDesigner.ValidateSql2(document.form1.tbSQL.value, ValidateSql_Callback);
        }
    }
    else
    {
        if (ValidateTable())
        {
            objTableDesigner.style.display = "none";
            objTablePleaseWait.style.display = "block";
            objCellPleaseWaitMessage.innerHTML = checkSqlText;
            Omega.Web.MSSQL.TableDesigner.ValidateSql(parseInt(document.form1.tableId.value, 10), trim(objSchema.value), trim(objTableName.value), trim(objTableFileGroup.value), trim(objTextFileGroup.value), columns, oldColumns, dataTypes, referenceKeys, indexes, ValidateSql_Callback);
        }
    }
    return false;
}

function ValidateSql_Callback(resp)
{
    objTableDesigner.style.display = "block";
    objTablePleaseWait.style.display = "none";
    respval = resp.value;
    alert(respval);
}

function btnExecuteSql_OnClick()
{
    HideAddEditColumnPanel();
    if (objCbWriteOwnSQL.checked)
    {
        document.form1.tbSQL.value = trim(document.form1.tbSQL.value);
        if (document.form1.tbSQL.value == "")
        {
            alert("There is no SQL to execute");
            SQLTabClicked(null);
            document.form1.tbSQL.focus();
        }
        else
        {
            objTableDesigner.style.display = "none";
            objTablePleaseWait.style.display = "block";
            objCellPleaseWaitMessage.innerHTML = savingTableText;
            Omega.Web.MSSQL.TableDesigner.CreateOrAlterTable2(document.form1.tbSQL.value, document.form1.tableId.value, CreateOrAlterTable_Callback);
        }
    }
    else
    {
        if (ValidateTable())
        {
            objTableDesigner.style.display = "none";
            objTablePleaseWait.style.display = "block";
            objCellPleaseWaitMessage.innerHTML = savingTableText;
            Omega.Web.MSSQL.TableDesigner.CreateOrAlterTable(parseInt(document.form1.tableId.value, 10), trim(objSchema.value), trim(objTableName.value), trim(objTableFileGroup.value), trim(objTextFileGroup.value), columns, oldColumns, dataTypes, referenceKeys, indexes, CreateOrAlterTable_Callback);
        }
    }
    return false;
}

function CreateOrAlterTable_Callback(resp)
{
    respval = resp.value;
    isError = true;
    message = "Unable to update the database";
    if (respval != null)
    {
        respvalarray = respval.split("|");
        message = respvalarray[1];
        if (respval.charAt(0) == "0")
        {
            isError = false;
        }
    }
    alert(message);
    if (isError)
    {
        objTableDesigner.style.display = "block";
        objTablePleaseWait.style.display = "none";
    }
    else
    {
        window.opener.TableDesignerComplete(tableMode, document.form1.tableId.value, trim(objTableName.value));
        self.close();
    }
}

function cbWriteOwnSQL_OnClick(obj)
{
    if (! obj.checked)
    {
        ColumnsClicked(null);
        document.form1.tbSQL.readOnly = true;
    }
    else
    {
        SQLTabClicked(null);
        document.form1.tbSQL.readOnly = false;
        document.form1.tbSQL.focus();

    }    
}